#include "cll1.h"

/* This is C<<1 rewrite of object polymorphism from
   http://en.wikipedia.org/wiki/Polymorphism_in_object-oriented_programming */

def_type(Animal);

def_mem(Actions)
{
 Animal method(init) (Animal self, str name);
 str method(talk) (Animal self);
};

def_obj(Animal)
{
 interface(Actions);
 char *name;
};

str cat_talk(Animal self)
{
 return "Meow!";
}

str dog_talk(Animal self)
{
 return "Arf! Arf!";
}

Animal animal_init(Animal self, str name)
{
 self->name = name;
 return self;
}

Actions cat_actions(Actions this)
{
 this->init = animal_init;
 this->talk = cat_talk;
}

Actions dog_actions(Actions this)
{
 this->init = animal_init;
 this->talk = dog_talk;
}

program
{
 int i;
 Animal animal[3];
 Actions cat = cat_actions();
 Actions dog = dog_actions();

 animal[0] = init_obj(Animal, Actions, cat)
  "Missy");
 animal[1] = init_obj(Animal, cat, "Mr. Bojangles");
 animal[2] = init_obj(Animal, dog, "Lassie"); 

 for_range(i, 0, 2)
 {
  printf("%s: %s\n", animal[i].name, _(talk, animal[i]));
 }
}
